    using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;


//BASE SCRIPT
namespace Fard
{

public class Fard
    {
        public static void Main()
        {

CategoryBuilder.Create("Doors", "funny doors mod", ModAPI.LoadSprite("door.png"));

Liquid.Register("Black", new black());
  
  
    
    ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Brick"), //item to get from
        NameOverride = "Rush -DOORS", //name
        NameToOrderByOverride = "A",
        DescriptionOverride = "Im walkin here!", //not needed
        CategoryOverride = ModAPI.FindCategory("Doors"), //category
        ThumbnailOverride = ModAPI.LoadSprite("thumbnails/rush thumb.png"), //thumnail image
        AfterSpawn = (Instance) => //after its spawned
        { 
            
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/rush.png"); //the texture for the item
            Instance.FixColliders(); //fix the colliders
  
             var phys = Instance.GetComponent<PhysicalBehaviour>();
             phys.Properties = ModAPI.FindPhysicalProperties("Human");

      AudioSource spawnSound = Instance.AddComponent<AudioSource>();spawnSound.minDistance = 1;spawnSound.maxDistance = 15;			
      	spawnSound.loop = true;AudioClip[] data = new AudioClip[]{ModAPI.LoadSound("sounds/rush.mp3")};spawnSound.clip = data[0];spawnSound.Play();


        }  
    }
);

 ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Brick"), //item to get from
        NameOverride = "Ambush -DOORS", //name
        NameToOrderByOverride = "A",
        DescriptionOverride = "Back for seconds!", //not needed
        CategoryOverride = ModAPI.FindCategory("Doors"), //category
        ThumbnailOverride = ModAPI.LoadSprite("thumbnails/ambush thumb.png"), //thumnail image
        AfterSpawn = (Instance) => //after its spawned
        { 
            
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/ambush.png"); //the texture for the item
            Instance.FixColliders(); //fix the colliders
  

             var phys = Instance.GetComponent<PhysicalBehaviour>();
             phys.Properties = ModAPI.FindPhysicalProperties("Human");

      AudioSource spawnSound = Instance.AddComponent<AudioSource>();spawnSound.minDistance = 1;spawnSound.maxDistance = 15;			
      	spawnSound.loop = true;AudioClip[] data = new AudioClip[]{ModAPI.LoadSound("sounds/ambush.mp3")};spawnSound.clip = data[0];spawnSound.Play();


        }  
    }
);


    ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Brick"), //item to get from
        NameOverride = "Screech -DOORS", //name
        NameToOrderByOverride = "A",
        DescriptionOverride = "Psst", //not needed
        CategoryOverride = ModAPI.FindCategory("Doors"), //category
        ThumbnailOverride = ModAPI.LoadSprite("thumbnails/screech thumb.png"), //thumnail image
        AfterSpawn = (Instance) => //after its spawned
        { 
            
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/screech.png"); //the texture for the item
            Instance.FixColliders(); //fix the colliders
      
 Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0f;
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0f;

            var childObject = new GameObject("funny glow");
                        childObject.transform.SetParent(Instance.transform);
                        childObject.transform.localPosition = new Vector3(0f, 0f);
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("overlays/screech glow.png");
                        childSprite.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                        var light = ModAPI.CreateLight(Instance.transform, new Color(100f, 100f, 100f, 1f), 1f, 1f);
    
                      Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.5f;
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.5f;


var phys = Instance.GetComponent<PhysicalBehaviour>();
             phys.Properties = ModAPI.FindPhysicalProperties("Human");



                               AudioSource AS = Instance.AddComponent<AudioSource>();
                                                  AS.minDistance = 1;
                                                  AS.maxDistance = 5;


          int index = 0;
          AudioClip[] AudioData = new AudioClip[]
     {
          ModAPI.LoadSound("sounds/psst.mp3"),
    };
                        
                        
                 
        Instance.AddComponent<UseEventTrigger>().Action = () =>
              {
                  AS.clip = AudioData[index];
                  AS.Play();
             };


        }  
    }
);


ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Brick"), //item to get from
        NameOverride = "Eyes -DOORS", //name
        NameToOrderByOverride = "A",
        DescriptionOverride = "Look at me", //not needed
        CategoryOverride = ModAPI.FindCategory("Doors"), //category
        ThumbnailOverride = ModAPI.LoadSprite("thumbnails/eyes thumb.png"), //thumnail image
        AfterSpawn = (Instance) => //after its spawned
        { 
            
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/eyes.png"); //the texture for the item
            Instance.FixColliders(); //fix the colliders

             var phys = Instance.GetComponent<PhysicalBehaviour>();
             phys.Properties = ModAPI.FindPhysicalProperties("Human");

             var light = ModAPI.CreateLight(Instance.transform, new Color(0f, 0f, 150f, 1f), 5f, 5f);
    



        }  
    }
);

  ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Brick"), //item to get from
        NameOverride = "Halt -DOORS", //name
        NameToOrderByOverride = "A",
        DescriptionOverride = "Description", //not needed
        CategoryOverride = ModAPI.FindCategory("Doors"), //category
        ThumbnailOverride = ModAPI.LoadSprite("thumbnails/halt thumb.png"), //thumnail image
        AfterSpawn = (Instance) => //after its spawned
        { 
            
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/halt.png"); //the texture for the item
            Instance.FixColliders(); //fix the colliders

             var phys = Instance.GetComponent<PhysicalBehaviour>();
             phys.Properties = ModAPI.FindPhysicalProperties("Human");

            var childObject = new GameObject("funny glow");
                        childObject.transform.SetParent(Instance.transform);
                        childObject.transform.localPosition = new Vector3(0f, 0f);
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("overlays/halt glow.png");
                        childSprite.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");  
                        var light = ModAPI.CreateLight(Instance.transform, new Color(0f, 50f, 100f, 1f), 3f, 3f);
    



        }  
    }
);


   ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Brick"), //item to get from
        NameOverride = "Jack -DOORS", //name
        NameToOrderByOverride = "A",
        DescriptionOverride = "Spoopy", //not needed
        CategoryOverride = ModAPI.FindCategory("Doors"), //category
        ThumbnailOverride = ModAPI.LoadSprite("thumbnails/jack thumb.png"), //thumnail image
        AfterSpawn = (Instance) => //after its spawned
        { 
            
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/jack.png"); //the texture for the item
            Instance.FixColliders(); //fix the colliders

var phys = Instance.GetComponent<PhysicalBehaviour>();
             phys.Properties = ModAPI.FindPhysicalProperties("Human");



        }  
    }
);
 
 

 
  ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"), //item to get from
        NameOverride = "Timothy -DOORS", //name
        NameToOrderByOverride = "A",
        DescriptionOverride = "Description", //not needed
        CategoryOverride = ModAPI.FindCategory("Doors"), //category
        ThumbnailOverride = ModAPI.LoadSprite("thumbnails/timothy thumb.png"), //thumnail image
        AfterSpawn = (Instance) => //after its spawned
        { 
            
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/timothy.png"); //the texture for the item
            Instance.FixColliders(); //fix the colliders
      
            var phys = Instance.GetComponent<PhysicalBehaviour>();
             phys.Properties = ModAPI.FindPhysicalProperties("Soft");


        }  
    }
);



ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Seek -DOORS",
                    NameToOrderByOverride = "A",
                    DescriptionOverride = "Here i come",
                    CategoryOverride = ModAPI.FindCategory("Doors"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/seek thumb.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var skin = ModAPI.LoadTexture("sprites/seek skin.png");
                     
                        var flesh = ModAPI.LoadTexture("sprites/black flesh.png");
                        
                        var bone = ModAPI.LoadTexture("sprites/no.png");
                   
                        person.SetBodyTextures(skin, flesh, bone, 1);

                   var dtweye = new GameObject("eye");
                   dtweye.transform.SetParent(Instance.transform.Find("Head"));
                   dtweye.transform.localPosition = new Vector3(0, 0f);
                   dtweye.transform.localScale = new Vector3(1f, 1f);
                   var dtweyeSprite = dtweye.AddComponent<SpriteRenderer>();
                   dtweyeSprite.sprite = ModAPI.LoadSprite("overlays/seek glow.png");
                   dtweye.GetComponent<SpriteRenderer>().sortingLayerName = "Middle";
                   dtweye.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("VeryBright");
                   
                    var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                          
                       var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                       var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();    
                          
                          
                           person.SetBruiseColor(0, 0, 0); 
                           person.SetSecondBruiseColor(0, 0, 0);
                           person.SetThirdBruiseColor(0, 0, 0); 
                           person.SetRottenColour(0, 0, 0); 
                           person.SetBloodColour(0, 0, 0);
                   
                        
                  foreach (LimbBehaviour limb in person.Limbs)
                       {
                           foreach (var body in person.Limbs)
                           {




                           }


                           cal.Sprites = limb.BloodDecal.Sprites;
                           cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                           cal.Color = new Color32(0, 0, 0, 200);
                           limb.BloodDecal = cal; //Lazy
                           limb.BloodLiquidType = "Black";
                           limb.CirculationBehaviour.Drain(limb.CirculationBehaviour.Limits.y);
                           limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("Black"), limb.CirculationBehaviour.Limits.y);
                           limb.PhysicalBehaviour.Properties = prop;
                       }
                       var Safe = new GameObject();
                       person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                       person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                       prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                       Safe.SetActive(false);
                       cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                       cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                       cal2.Color = new Color32(0, 0, 0, 200);
                       person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                       foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                       {
                           var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                           main.startColor = new ParticleSystem.MinMaxGradient(new Color32(0, 0, 0, 200));
                           if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                           {
                               thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                           }
                           var renderer = thi.gameObject.GetComponent<ParticleSystemRenderer>();
                           renderer.material.color = new Color32(0, 0, 0, 200);
                       }

                       foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                       {
                           var moon = thi.main;
                           moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(0, 0, 0, 200));
                       }

                       foreach (var con in person.BloodExplosionPrefab.GetComponentsInChildren<FancyBloodSplatController>())
                       {
                           con.Decal = cal2;
                       }

                       foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                       {
                           var moon = thi.main;
                           moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(0, 0, 0, 200));
                           if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                           {
                               prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                           }
                       }



                    }
                }
            );

 
   ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Stick"), //item to get from
        NameOverride = "Seek Puddle -DOORS", //name
        NameToOrderByOverride = "A",
        DescriptionOverride = "Description", //not needed
        CategoryOverride = ModAPI.FindCategory("Doors"), //category
        ThumbnailOverride = ModAPI.LoadSprite("thumbnails/puddle thumb.png"), //thumnail image
        AfterSpawn = (Instance) => //after its spawned
        { 
            
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/seek puddle.png"); //the texture for the item
            Instance.FixColliders(); //fix the colliders

             var phys = Instance.GetComponent<PhysicalBehaviour>();
             phys.Properties = ModAPI.FindPhysicalProperties("Human");

         
        }  
    }
);


     ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Stick"), //item to get from
        NameOverride = "Seek Eye -DOORS", //name
        NameToOrderByOverride = "A",
        DescriptionOverride = "Description", //not needed
        CategoryOverride = ModAPI.FindCategory("Doors"), //category
        ThumbnailOverride = ModAPI.LoadSprite("thumbnails/eye thumb.png"), //thumnail image
        AfterSpawn = (Instance) => //after its spawned
        { 
            
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/seek eye.png"); //the texture for the item
            Instance.FixColliders(); //fix the colliders
      
            var childObject = new GameObject("funny glow");
                        childObject.transform.SetParent(Instance.transform);
                        childObject.transform.localPosition = new Vector3(0f, 0f);
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("overlays/eye glow.png");
                        childSprite.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");  
                        var light = ModAPI.CreateLight(Instance.transform, new Color(100f, 100f, 100f, 1f), 1f, 1f);

var phys = Instance.GetComponent<PhysicalBehaviour>();
             phys.Properties = ModAPI.FindPhysicalProperties("Human");

         
        }  
    }
);


ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Figure -DOORS",
                    NameToOrderByOverride = "A",
                    DescriptionOverride = "Description",
                    CategoryOverride = ModAPI.FindCategory("Doors"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/figure thumb.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var skin = ModAPI.LoadTexture("sprites/figure skin.png");
                     
                        var flesh = ModAPI.LoadTexture("sprites/figure flesh.png");
                        
                        var bone = ModAPI.LoadTexture("sprites/figure bone.png");
                   
                        person.SetBodyTextures(skin, flesh, bone, 1);

             
                       Instance.transform.Find("BackLeg").Find("Foot").gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                        Instance.transform.Find("FrontLeg").Find("FootFront").gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                       
                        var arm3 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                        var arm4 = Instance.transform.Find("BackArm").Find("LowerArm");
                        var leg3 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
                        var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
                        arm3.transform.localScale = new Vector3(1f, 2.3f);
                        arm4.transform.localScale = new Vector3(1f, 2.3f);
                        arm3.transform.localPosition = new Vector3(0f, -0.8f);
                        arm4.transform.localPosition = new Vector3(0f, -0.8f);
                        leg3.transform.localScale = new Vector3(1f, 1.8f);
                        leg4.transform.localScale = new Vector3(1f, 1.8f);
                        leg3.transform.localPosition = new Vector3(0f, -1f);
                        leg4.transform.localPosition = new Vector3(0f, -1f);


                        var cObj = new GameObject("bones");
                        cObj.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
                        cObj.transform.localPosition = new Vector3(0.0f, 0.0f);
                        cObj.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        cObj.transform.localScale = new Vector3(1f, 1f);
                        var cSpr = cObj.AddComponent<SpriteRenderer>();
                        cSpr.sprite = ModAPI.LoadSprite("overlays/figure bones.png");
                        cSpr.sortingLayerName = "Middle";


var headyss = Instance.transform.Find("Head");
           var phys12 = headyss.GetComponent<PhysicalBehaviour>();
           var prop12 = ModAPI.FindPhysicalProperties("Human");
           prop12.Sharp = true;
           prop12.SharpAxes = new[]
           {
               new SharpAxis(Vector2.right, 0f, 0.15f, true, true),
           };
           phys12.Properties = prop12;


  foreach (var body in Instance.GetComponent<PersonBehaviour>().Limbs)
            {
              body.transform.root.localScale *= 1.02f; 
            }



                    }
                }
            );

  
  ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Stick"), //item to get from
        NameOverride = "Window -DOORS", //name
        NameToOrderByOverride = "A",
        DescriptionOverride = "Description", //not needed
        CategoryOverride = ModAPI.FindCategory("Doors"), //category
        ThumbnailOverride = ModAPI.LoadSprite("thumbnails/window thumb.png"), //thumnail image
        AfterSpawn = (Instance) => //after its spawned
        { 
            
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/window.png"); //the texture for the item
            Instance.FixColliders(); //fix the colliders

             var phys = Instance.GetComponent<PhysicalBehaviour>();
             phys.Properties = ModAPI.FindPhysicalProperties("Human");

            var childObject = new GameObject("funny glow");
                        childObject.transform.SetParent(Instance.transform);
                        childObject.transform.localPosition = new Vector3(0f, 0f);
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("overlays/window glow.png");
                        childSprite.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");  
                        var light = ModAPI.CreateLight(Instance.transform, new Color(100f, 100f, 100f, 1f), 1f, 1f);
    



        }  
    }
);





      ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"), //item to get from
        NameOverride = "Room key -DOORS", //name
        NameToOrderByOverride = "A",
        DescriptionOverride = "Description", //not needed
        CategoryOverride = ModAPI.FindCategory("Doors"), //category
        ThumbnailOverride = ModAPI.LoadSprite("thumbnails/key thumb.png",1.5f), //thumnail image
        AfterSpawn = (Instance) => //after its spawned
        { 
            
            
            
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/key.png",1.5f); //the texture for the item
            Instance.FixColliders(); //fix the colliders
      

        }  
    }
);


      ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"), //item to get from
        NameOverride = "Electric Room key -DOORS", //name
        NameToOrderByOverride = "A",
        DescriptionOverride = "Description", //not needed
        CategoryOverride = ModAPI.FindCategory("Doors"), //category
        ThumbnailOverride = ModAPI.LoadSprite("thumbnails/electric key thumb.png",1.5f), //thumnail image
        AfterSpawn = (Instance) => //after its spawned
        { 
            
            
            
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/electric key.png",1.5f); //the texture for the item
            Instance.FixColliders(); //fix the colliders
      

        }  
    }
);

     ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"), //item to get from
        NameOverride = "Lock -DOORS", //name
        NameToOrderByOverride = "A",
        DescriptionOverride = "Description", //not needed
        CategoryOverride = ModAPI.FindCategory("Doors"), //category
        ThumbnailOverride = ModAPI.LoadSprite("thumbnails/lock thumb.png"), //thumnail image
        AfterSpawn = (Instance) => //after its spawned
        { 
            
            
            
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/lock.png"); //the texture for the item
            Instance.FixColliders(); //fix the colliders
      

        }  
    }
);

     ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"), //item to get from
        NameOverride = "Lockpick 1 -DOORS", //name
        NameToOrderByOverride = "A",
        DescriptionOverride = "Description", //not needed
        CategoryOverride = ModAPI.FindCategory("Doors"), //category
        ThumbnailOverride = ModAPI.LoadSprite("thumbnails/lockpick 1 thumb.png"), //thumnail image
        AfterSpawn = (Instance) => //after its spawned
        { 
            
            
            
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/lockpick 1.png"); //the texture for the item
            Instance.FixColliders(); //fix the colliders
      

        }  
    }
);


     ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"), //item to get from
        NameOverride = "Lockpick 2 -DOORS", //name
        NameToOrderByOverride = "A",
        DescriptionOverride = "Description", //not needed
        CategoryOverride = ModAPI.FindCategory("Doors"), //category
        ThumbnailOverride = ModAPI.LoadSprite("thumbnails/lockpick 2 thumb.png"), //thumnail image
        AfterSpawn = (Instance) => //after its spawned
        { 
            
            
            
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/lockpick 2.png"); //the texture for the item
            Instance.FixColliders(); //fix the colliders
      

        }  
    }
);


    ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"), //item to get from
        NameOverride = "Vitamins -DOORS", //name
        NameToOrderByOverride = "A",
        DescriptionOverride = "Description", //not needed
        CategoryOverride = ModAPI.FindCategory("Doors"), //category
        ThumbnailOverride = ModAPI.LoadSprite("thumbnails/vitamins thumb.png"), //thumnail image
        AfterSpawn = (Instance) => //after its spawned
        { 
            
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/vitamins.png"); //the texture for the item
            Instance.FixColliders(); //fix the colliders
      
            var phys = Instance.GetComponent<PhysicalBehaviour>();
             phys.Properties = ModAPI.FindPhysicalProperties("Bowling Pin");


        }  
    }
);

      ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"), //item to get from
        NameOverride = "Lighter -DOORS", //name
        NameToOrderByOverride = "A",
        DescriptionOverride = "Description", //not needed
        CategoryOverride = ModAPI.FindCategory("Doors"), //category
        ThumbnailOverride = ModAPI.LoadSprite("thumbnails/lighter thumb.png"), //thumnail image
        AfterSpawn = (Instance) => //after its spawned
        { 
            
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/lighter.png"); //the texture for the item
            Instance.FixColliders(); //fix the colliders
           
                 var childObject = new GameObject("funny glow");
                        childObject.transform.SetParent(Instance.transform);
                        childObject.transform.localPosition = new Vector3(0f, 0f);
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("overlays/lighter glow.png");
                        childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                        var light = ModAPI.CreateLight(Instance.transform, new Color(150f, 10f, 0f, 1f), 1.5f, 1.5f);                
         

                        
                    
        }  
    }
);

    ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"), //item to get from
        NameOverride = "Flashlight -DOORS", //name
        NameToOrderByOverride = "A",
        DescriptionOverride = "Description", //not needed
        CategoryOverride = ModAPI.FindCategory("Doors"), //category
        ThumbnailOverride = ModAPI.LoadSprite("thumbnails/flashlight thumb.png"), //thumnail image
        AfterSpawn = (Instance) => //after its spawned
        { 
            
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/flashlight.png"); //the texture for the item
            Instance.FixColliders(); //fix the colliders
           
                 var childObject = new GameObject("funny glow");
                        childObject.transform.SetParent(Instance.transform);
                        childObject.transform.localPosition = new Vector3(0f, 0f);
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("overlays/flashlight glow.png");
                        childSprite.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                        var light = ModAPI.CreateLight(Instance.transform, new Color(100f, 20f, 100f, 1f), 3f, 2f);                
         

                        
                    
        }  
    }
);


ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Doors music box -DOORS",
                    NameToOrderByOverride = "A",
                    DescriptionOverride = "Plays music from Doors",
                    CategoryOverride = ModAPI.FindCategory("Doors"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/music thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/music box.png");

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = .1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = .1f;

                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");

                        Instance.transform.localRotation = Quaternion.Euler(0f, 0f, 0f);


                        AudioSource AS = Instance.AddComponent<AudioSource>();
                        AS.minDistance = 1;
                        AS.maxDistance = 5;
                        

                        int index = 0;
                        AudioClip[] AudioData = new AudioClip[]
                        {
                            ModAPI.LoadSound("music/m1.mp3"),
                            ModAPI.LoadSound("music/m2.mp3"),
                            ModAPI.LoadSound("music/m3.mp3"),
                            ModAPI.LoadSound("music/m4.mp3"),
                            ModAPI.LoadSound("music/m5.mp3"),
                            ModAPI.LoadSound("music/m6.mp3"),
                        };


                        Instance.AddComponent<UseEventTrigger>().Action = () =>
                        {
                            AS.clip = AudioData[index];
                            AS.Play();

                            index++;
                            if (index == AudioData.Length) index = 0;
                        };
                     
                     Instance.FixColliders();
                   
                    }
                }
             );



 
        }  
    }

public class black : Liquid
{
    public black()
    {
        this.Color = new Color32(0, 0, 0, 200);
    }

    public override void OnEnterContainer(BloodContainer container)
    {
    }

      public override void OnEnterLimb(LimbBehaviour limb)
    {
        if (limb.SpeciesIdentity == "Android" && UnityEngine.Random.value > 0.995f)
        {
          limb.PhysicalBehaviour.Charge += 0.1f;
        }
    }

    public override void OnExitContainer(BloodContainer container)
    {
    }

    public const string ID = "Ink";//<-- You should change the name of liquid here
}
}




    